# coding: utf-8

"""
    Payment Gateway API Specification.

    The documentation here is designed to provide all of the technical guidance required to consume and integrate with our APIs for payment processing. To learn more about our APIs please visit https://docs.firstdata.com/org/gateway.  # noqa: E501

    The version of the OpenAPI document: 6.12.0.20200605.001
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from openapi_client.configuration import Configuration


class PaymentTokenUpdateResponseAllOf(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'request_status': 'str',
        'request_time': 'int',
        'errors': 'list[Error]'
    }

    attribute_map = {
        'request_status': 'requestStatus',
        'request_time': 'requestTime',
        'errors': 'errors'
    }

    def __init__(self, request_status=None, request_time=None, errors=None, local_vars_configuration=None):  # noqa: E501
        """PaymentTokenUpdateResponseAllOf - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._request_status = None
        self._request_time = None
        self._errors = None
        self.discriminator = None

        if request_status is not None:
            self.request_status = request_status
        if request_time is not None:
            self.request_time = request_time
        if errors is not None:
            self.errors = errors

    @property
    def request_status(self):
        """Gets the request_status of this PaymentTokenUpdateResponseAllOf.  # noqa: E501

        The status of the request.  # noqa: E501

        :return: The request_status of this PaymentTokenUpdateResponseAllOf.  # noqa: E501
        :rtype: str
        """
        return self._request_status

    @request_status.setter
    def request_status(self, request_status):
        """Sets the request_status of this PaymentTokenUpdateResponseAllOf.

        The status of the request.  # noqa: E501

        :param request_status: The request_status of this PaymentTokenUpdateResponseAllOf.  # noqa: E501
        :type: str
        """
        allowed_values = ["FAILED", "SUCCESS", "PARTIAL_SUCCESS"]  # noqa: E501
        if self.local_vars_configuration.client_side_validation and request_status not in allowed_values:  # noqa: E501
            raise ValueError(
                "Invalid value for `request_status` ({0}), must be one of {1}"  # noqa: E501
                .format(request_status, allowed_values)
            )

        self._request_status = request_status

    @property
    def request_time(self):
        """Gets the request_time of this PaymentTokenUpdateResponseAllOf.  # noqa: E501

        Time of the request.  # noqa: E501

        :return: The request_time of this PaymentTokenUpdateResponseAllOf.  # noqa: E501
        :rtype: int
        """
        return self._request_time

    @request_time.setter
    def request_time(self, request_time):
        """Sets the request_time of this PaymentTokenUpdateResponseAllOf.

        Time of the request.  # noqa: E501

        :param request_time: The request_time of this PaymentTokenUpdateResponseAllOf.  # noqa: E501
        :type: int
        """

        self._request_time = request_time

    @property
    def errors(self):
        """Gets the errors of this PaymentTokenUpdateResponseAllOf.  # noqa: E501


        :return: The errors of this PaymentTokenUpdateResponseAllOf.  # noqa: E501
        :rtype: list[Error]
        """
        return self._errors

    @errors.setter
    def errors(self, errors):
        """Sets the errors of this PaymentTokenUpdateResponseAllOf.


        :param errors: The errors of this PaymentTokenUpdateResponseAllOf.  # noqa: E501
        :type: list[Error]
        """

        self._errors = errors

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PaymentTokenUpdateResponseAllOf):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, PaymentTokenUpdateResponseAllOf):
            return True

        return self.to_dict() != other.to_dict()
