# coding: utf-8

"""
    Payment Gateway API Specification.

    The documentation here is designed to provide all of the technical guidance required to consume and integrate with our APIs for payment processing. To learn more about our APIs please visit https://docs.firstdata.com/org/gateway.  # noqa: E501

    The version of the OpenAPI document: 6.12.0.20200605.001
    Generated by: https://openapi-generator.tech
"""


from __future__ import absolute_import

import unittest
import datetime

import openapi_client
from openapi_client.models.ach_sale_transaction import AchSaleTransaction  # noqa: E501
from openapi_client.rest import ApiException

class TestAchSaleTransaction(unittest.TestCase):
    """AchSaleTransaction unit test stubs"""

    def setUp(self):
        pass

    def tearDown(self):
        pass

    def make_instance(self, include_optional):
        """Test AchSaleTransaction
            include_option is a boolean, when False only required
            params are included, when True both required and
            optional params are included """
        # model = openapi_client.models.ach_sale_transaction.AchSaleTransaction()  # noqa: E501
        if include_optional :
            return AchSaleTransaction(
                request_type = 'PaymentCardCreditTransaction', 
                transaction_amount = {"total":10.24,"currency":"USD","components":{"subtotal":8.0,"localTax":1.0,"shipping":1.24}}, 
                store_id = '12345500000', 
                merchant_transaction_id = '30dd879c-ee2f-11db-8314-0800200c9a66', 
                transaction_origin = 'ECOM', 
                order = {"orderId":"ABC12345","billing":{"name":"John Doe","customerId":"1234567890"},"shipping":{"name":"John Doe","address":{"address1":"123 Main St.","city":"Sandy Springs","region":"Georgia","postalCode":"30303","country":"USA"}}}, 
                payment_method = openapi_client.models.tele_check_ach_payment_method.TeleCheckAchPaymentMethod(
                    ach_type = 'TeleCheckICAPaymentMethod', 
                    routing_number = '1283673312', 
                    account_number = '2398649823984789', 
                    account_type = 'C', 
                    check_number = '9878867880', 
                    check_type = 'P', 
                    product_code = '128367', 
                    manual_id_info = {"idType":"DL","idData":"12345678"}, 
                    supplement_id_info = {"idType":"DL","idData":"12345678"}, 
                    agent_id = 'RVK001', 
                    terminal_id = '1283673312', 
                    registration_id = '12345', 
                    registration_date = 'Tue Oct 01 19:00:00 CDT 2019', 
                    release_type = 'P', 
                    vip_customer = 'Y', 
                    session_id = 'fb2e77d.47a0479900504cb3ab4a1f626d174d2d', 
                    terminal_state = 'GA', 
                    terminal_city = 'Atlanta', 
                    ach_bill_to = openapi_client.models.tele_check_ach_payment_method_ach_bill_to.TeleCheckAchPaymentMethod_achBillTo(
                        first_name = 'R2-D2', 
                        last_name = 'O'Calloway', 
                        address_one = '1234 Line Ave S.', 
                        address_two = 'Ste 602', 
                        city = 'Atlanta', 
                        state = 'GA', 
                        zip = '30040-1309', 
                        phone = '9973322990', 
                        email = 'abcd.1234@fiserv.com', 
                        country_code = 'US', ), )
            )
        else :
            return AchSaleTransaction(
                request_type = 'PaymentCardCreditTransaction',
                transaction_amount = {"total":10.24,"currency":"USD","components":{"subtotal":8.0,"localTax":1.0,"shipping":1.24}},
                payment_method = openapi_client.models.tele_check_ach_payment_method.TeleCheckAchPaymentMethod(
                    ach_type = 'TeleCheckICAPaymentMethod', 
                    routing_number = '1283673312', 
                    account_number = '2398649823984789', 
                    account_type = 'C', 
                    check_number = '9878867880', 
                    check_type = 'P', 
                    product_code = '128367', 
                    manual_id_info = {"idType":"DL","idData":"12345678"}, 
                    supplement_id_info = {"idType":"DL","idData":"12345678"}, 
                    agent_id = 'RVK001', 
                    terminal_id = '1283673312', 
                    registration_id = '12345', 
                    registration_date = 'Tue Oct 01 19:00:00 CDT 2019', 
                    release_type = 'P', 
                    vip_customer = 'Y', 
                    session_id = 'fb2e77d.47a0479900504cb3ab4a1f626d174d2d', 
                    terminal_state = 'GA', 
                    terminal_city = 'Atlanta', 
                    ach_bill_to = openapi_client.models.tele_check_ach_payment_method_ach_bill_to.TeleCheckAchPaymentMethod_achBillTo(
                        first_name = 'R2-D2', 
                        last_name = 'O'Calloway', 
                        address_one = '1234 Line Ave S.', 
                        address_two = 'Ste 602', 
                        city = 'Atlanta', 
                        state = 'GA', 
                        zip = '30040-1309', 
                        phone = '9973322990', 
                        email = 'abcd.1234@fiserv.com', 
                        country_code = 'US', ), ),
        )

    def testAchSaleTransaction(self):
        """Test AchSaleTransaction"""
        inst_req_only = self.make_instance(include_optional=False)
        inst_req_and_optional = self.make_instance(include_optional=True)


if __name__ == '__main__':
    unittest.main()
